<template>
  <div class="container">
    <div class="title_Login">
      <div v-if="changeLogin == 1">
        <div class="title" @click="toCodeLogin">
          <div :class="changeLogin == 2 ? 'change_login' : ''">验证码登录</div>
        </div>
        <div class="title" @click="toLogin">
          <div :class="changeLogin == 1 ? 'change_login' : ''">
            账号密码登录
          </div>
        </div>
      </div>

      <div v-else-if="changeLogin == 2">
        <div class="title" @click="toLogin">
          <div :class="changeLogin == 1 ? 'change_login' : ''">
            账号密码登录
          </div>
        </div>
        <div class="title" @click="toCodeLogin">
          <div :class="changeLogin == 2 ? 'change_login' : ''">验证码登录</div>
        </div>
      </div>
    </div>
    <div>
      <el-form
        :model="loginForm"
        :rules="loginFormRules"
        ref="loginFormRef"
        class="demo-ruleForm"
      >
        <el-form-item ref="phone" prop="phone">
          <img
            class="img_l"
            src="../../../assets/img/login/username.png"
            alt=""
          />
          <el-input
            v-model="loginForm.phone"
            placeholder="请输入手机号"
            maxlength="11"
          ></el-input>
        </el-form-item>
        <el-form-item
          v-if="changeLogin == 1"
          :prop="changeLogin == 1 ? 'password' : ''"
          ref="password"
        >
          <img
            class="img_l"
            src="../../../assets/img/login/password.png"
            alt=""
          />
          <el-input
            v-model="loginForm.password"
            :type="isShowPwd ? 'password' : 'text'"
            maxlength="20"
            placeholder="请输入密码"
          ></el-input>
          <img
            @click="changePwdStatus()"
            v-if="!isShowPwd"
            class="img_r"
            src="../../../assets/img/login/eye01.png"
            alt=""
          />
          <img
            @click="changePwdStatus()"
            v-if="isShowPwd"
            class="img_r"
            src="../../../assets/img/login/eye01.png"
            alt=""
          />
        </el-form-item>

        <el-form-item
          v-else-if="changeLogin == 2"
          :prop="changeLogin == 2 ? 'code' : ''"
          ref="code"
        >
          <img class="img_l" src="@/assets/img/reset/code.png" alt=""/>
          <el-input
            v-model="loginForm.code"
            placeholder="请输入短信验证码"
            maxlength="20"
          ></el-input>
          <!-- 短信验证码 -->
          <div class="phoneCode">
            <span class="code" v-show="showCode" @click="getCode"
            >获取验证码</span
            >
            <span v-show="!showCode" class="count">{{ count }} s</span>
          </div>
        </el-form-item>
        <el-form-item style="margin: 40px 0 0 0"></el-form-item>
        <el-form-item>
          <el-button @click="submitForm()">登 录</el-button>
        </el-form-item>
        <div v-if="changeLogin == 1" class="box">
          <div>
            <div class="fr" @click="register()">还没有账号？立即注册</div>
            <div class="fl" @click="forgetPwd()">忘记密码？</div>
          </div>
          <!-- <div class="fc">忘记密码请联系管理员邮箱：service@campcenter.cn</div> -->
        </div>
      </el-form>
    </div>
  </div>
</template>

<script>
  /* eslint-disable */
  import Cookie from "js-cookie";
  import {login, loginCode} from "r/index/login";
  import {mobileCheck} from "@/common/utils.js";
  import {intervalTime} from "store/time";

  export default {
    name: "index-login",
    data() {
      return {
        isShowPwd: true, // 控制密码显示隐藏
        // 手机验证短信
        showCode: true,
        count: "",
        timer: null,
        codeTime: "", //手机验证码倒计时时间
        loginForm: {
          phone: null,
          password: null,
          code: null,
        },
        // 表单验证规则对象
        loginFormRules: {
          // 对手机号进行校验
          phone: [
            {required: true, message: "请输入手机号", trigger: "blur"},
            {
              validator: function (rule, value, callback) {
                if (mobileCheck(value) === false) {
                  callback(new Error("请输入正确的手机号"));
                } else {
                  callback();
                }
              },
              trigger: "blur",
            },
          ],
          // 对密码进行校验
          password: [
            {
              required: true,
              message: "请输入密码",
              transform: (value) => value,
              trigger: "blur",
            },
            {
              type: "string",
              message: "请输入不包含空格的字符",
              trigger: "blur",
              transform(value) {
                if (value && value.indexOf(" ") === -1) {
                  return value;
                } else {
                  return false;
                }
              },
            },
            {
              trigger: "blur",
              validator: (rule, value, callback) => {
                var passwordreg = /^[a-zA-Z0-9]{6,12}$/;
                // /(?=.*\d)(?=.*[a-zA-Z]).{6,12}/;
                if (!passwordreg.test(value)) {
                  callback(new Error("请输入6-12位，包含数字/字母,"));
                } else {
                  callback();
                }
              },
            },
          ],
          // 对验证码进行校验
          code: [
            {required: true, message: "请输入验证码", trigger: "blur"},
            {min: 6, max: 20, message: "请输入正确的验证码", trigger: "blur"},
          ],
        },
        changeLogin: 2,
      };
    },
    created() {
      this.$emit("getStatus", false);
      const code = this.$store.state.indexIdentity;
      const endTime = window.localStorage.getItem("login_code_time" + code);

      if (endTime && Number(endTime) > new Date().getTime()) {
        this.loginForm.phone = phone;
        this.intervalHandle(new Date(), Number(endTime));
      }
      this.commonApi(31)
    },
    methods: {
      // 定时器倒计时
      intervalHandle(startTime, endTime) {
        // 时间差
        const timeLag = intervalTime(startTime, endTime);
        console.log(timeLag);
        if (!this.timer) {
          this.count = timeLag - 1;
          this.showCode = false;
          this.timer = setInterval(() => {
            if (this.count > 0 && this.count <= timeLag) {
              this.count--;
            } else {
              this.showCode = true;
              clearInterval(this.timer);
              this.timer = null;
            }
          }, 1000);
        }
      },
      // 获取手机验证短信
      getCode() {
        if (!this.loginForm.phone) {
          return this.$message.error("请输入手机号");
        }
        // if (!this.codeTime) {
        //   return this.$message.error("您已经获取验证码，请去邮箱中进行查看");
        // }
        // 接口获得验证码
        loginCode({
          phone: this.loginForm.phone,
        }).then((res) => {
          console.log(res, "passwordCode");
          if (res.data.code != 200) {
            return this.$message.error(res.data.message);
          }
          this.$message.success(res.data.message);
          this.codeTime = res.data.data.now * 1000;
          // console.log(this.codeTime)
          let code = this.$store.state.indexIdentity;
          window.localStorage.setItem(
            "login_code_time" + code,
            res.data.data.now * 1000
          );
          this.intervalHandle(new Date(), res.data.data.now * 1000);
        });
      },
      // 忘记账号/密码
      forgetPwd() {
        let code = this.$store.state.indexIdentity;
        this.$router.push("/reset?code=" + code);
      },

      // 去注册
      register() {
        let code = this.$store.state.indexIdentity;
        this.$router.push("/register?code=" + code);
      },
      // 改变密码显示状态
      changePwdStatus() {
        this.isShowPwd = !this.isShowPwd;
      },
      toLogin() {
        this.loginForm = {};
        this.changeLogin = 1;
        this.$nextTick(() => {
          this.$refs["loginFormRef"].clearValidate();
        });
      },
      toCodeLogin() {
        this.loginForm = {};
        this.changeLogin = 2;
        this.$nextTick(() => {
          this.$refs["loginFormRef"].clearValidate();
        });
      },
      // 登录
      submitForm() {
        this.$refs["loginFormRef"].validate((valid) => {
          if (!valid) return;
          let obj = {};
          if (this.changeLogin == 1) {
            obj.phone = this.loginForm.phone;
            obj.password = this.loginForm.password;
          } else {
            obj.phone = this.loginForm.phone;
            obj.code = this.loginForm.code;
          }
          console.log(obj);
          login(obj).then((res) => {
            console.log(res, "login");
            if (res.data.code != 200) {
              return this.$message.error(res.data.message);
            }
            // this.$message.success("登录成功");
            // 跳转到报名
            const code = this.$store.state.indexIdentity;
            // token存储
            this.$store.commit('login', res.data.token);
            window.localStorage.setItem("index-phone-all", this.loginForm.phone);
            window.localStorage.setItem("email" + code, res.data.email);
            // 报名信息
            window.localStorage.setItem("camp_name" + code, res.data.cam.name);
            //获取主题色
            window.localStorage.setItem("system_color" + code,
              res.data.cam.system_color
            );
            this.$router.replace("/signUp/undefined?code=" + code);
          });
        });
      },
    },
  };
</script>

<style scoped lang="scss">
  .flex {
    display: flex;
  }

  .container {
    height: 440px;
    background: #ffffff;
    box-shadow: 0px 1px 18px 0px rgba(0, 0, 0, 0.06);
    border-radius: 8px;
    padding: 40px 60px;
    margin-top: 0;
    overflow: hidden;

    .title_Login {
      position: relative;
      margin: 19px 0 0 0;
      text-align: center;

      .title {
        height: 20px;
        font-size: 16px;
        font-weight: 500;
        color: var(--color);
        line-height: 20px;
        text-align: right;
      }

      .change_login {
        font-size: 22px;
        margin-top: 32px;
        color: black;
        text-align: center;
      }
    }

    .el-form {
      margin-top: 60px;

      .el-form-item {
        position: relative;
        margin-bottom: 30px;

        &:last-child {
          margin: 0;
        }

        .phoneCode {
          position: absolute;
          z-index: 999;
          top: 50%;
          right: 25px;
          transform: translate(0, -50%);
          cursor: pointer;

          .code {
            font-size: 14px;
            font-weight: 600;
            color: var(--color);
          }
        }

        img.img_l {
          position: absolute;
          left: 25px;
          top: 50%;
          transform: translate(-50%, -50%);
          z-index: 1000;
        }

        img.img_r {
          position: absolute;
          right: 15px;
          top: 50%;
          transform: translate(0, -50%);
          z-index: 1000;
        }

        ::v-deep .el-input__inner {
          height: 50px;
          line-height: 50px;
          padding: 0 10px 0 50px;
          border-radius: 0;
          color: #4d4d4d;
          border: 0;
          border-bottom: 2px solid #d9d9d9;

          &:focus {
            border-bottom-color: var(--color);
          }
        }

        ::v-deep .el-form-item__error {
          color: #e0823d;
        }

        .el-button {
          width: 100%;
          height: 60px;
          background: var(--color);
          border-radius: 4px;
          opacity: 0.8;
          line-height: 50px;
          text-align: center;
          color: #fff;
          font-size: 16px;
          padding: 0;
          margin: 30px 0 0 0;
          border: none;
        }
      }

      .box {
        height: 18px;
        // display: block;
        display: flex;
        flex-direction: column;

        .fl {
          float: right;
          height: 18px;
          line-height: 18px;
          color: #999999;
          margin-top: -10px;
          cursor: pointer;

          &:hover {
            color: var(--color);
            text-decoration: underline;
          }
        }

        .fr {
          float: left;
          height: 18px;
          line-height: 18px;
          color: #999999;
          margin-top: -10px;
          cursor: pointer;

          &:hover {
            color: var(--color);
            text-decoration: underline;
          }
        }

        .fc {
          font-size: 4px;
          float: right;
          // height: 18px;
          line-height: 18px;
          color: #999999;
          margin-top: 10px;
          // cursor: pointer;
          // &:hover {
          //   color: #563279;
          //   text-decoration: underline;
          // }
        }
      }
    }
  }
</style>
